local configTable = require("sve.journal.config")
local config = configTable[1]

local function saveConfig()
    mwse.saveConfig("Amlioration du journal", config)
----mwse.log("mwse.saveConfig(\"journal search and edit\", config)")
end

local function setSliderLabelAsPercentage(self)
    local newValue = ""

    if self.elements.slider then
        newValue = self.elements.slider.widget.current + self.min
    end

    self.elements.label.text = self.label .. " : " .. newValue .. " %"

end

local function setSliderLabelAsTenthPercentage(self)
    local newValue = ""

    if self.elements.slider then
        newValue = tostring( tonumber( self.elements.slider.widget.current + self.min ) / 10 )
    end

    self.elements.label.text = self.label .. " : " .. newValue .. " %"

end

local function enabledGetText(self)
    local text = (
        self.variable.value and
        "Activ" or
        "Dsactiv"
    )
    -- one frame timer to run after MCM page is constructed
    local state = self.variable.value
    timer.start({duration=0.01, type=timer.real, callback = function()
       local menuMCM = tes3ui.findMenu(tes3ui.registerID("MWSE:ModConfigMenu"))
       local contents = menuMCM:findChild(tes3ui.registerID("Label: Mod Config Options"))
       if contents ~= nil then
       	  contents.parent.parent.visible = state
       end
    end } )
    return text
end

local function restoreGetText(self)
   return "Restaurer"
end

local function restoreDefaults()
--mwse.log("restore config = configTable[2] ...")
   for key, value in pairs(configTable[2]) do
      if type(value) == "table" then
         for key2,value2 in pairs(value) do
            config[key][key2]=value2
--mwse.log("config[%s][%s]=%s", tostring(key), tostring(key2), tostring(value2))
         end
      else
         config[key] = value
--mwse.log("config[%s]=%s", tostring(key), tostring(value))
      end
    end
    local menuMCM = tes3ui.findMenu(tes3ui.registerID("MWSE:ModConfigMenu"))
    local contents = menuMCM:findChild(tes3ui.registerID("PartDragMenu_main"))
    local children = contents:findChild(tes3ui.registerID("PartScrollPane_pane")).children
    for i = 1, #children do
       if children[i].text == "Amlioration du journal" then
          children[i]:triggerEvent("mouseClick")
       end
    end
end

local function registerRestoreDefaultsButton()
   local menuMCM = tes3ui.findMenu(tes3ui.registerID("MWSE:ModConfigMenu"))
   local label = menuMCM:findChild(tes3ui.registerID("Label: Default Settings"))
   label.parent.parent.children[1]:register("mouseClick", restoreDefaults)
end

local function padOptionsBottom(self)
    local menuMCM = tes3ui.findMenu(tes3ui.registerID("MWSE:ModConfigMenu"))
    local contents = menuMCM:findChild(tes3ui.registerID("Label: Mod Config Options"))
    if contents ~= nil then
       contents.parent.paddingBottom = 5
    end
end

return {
    name = "Amlioration du journal",
    pages = {
        {
            label = "Prfrences",
            class = "SideBarPage",
            components = {
               {
               class = "Category",
               label = "Amlioration du journal",
               components = {
	           {
                   class = "YesNoButton",
                   description = "(Ds)activer le mod",
                   variable = {
                                id = "enabled",
                                class = "TableVariable",
                                table = config,
                     },
                   postCreate = enabledGetText,
                   getText = enabledGetText,
                   },
		   },
	       },
	       {
               class = "Category",
               label = "Options de configuration du mod",
	       postCreate = padOptionsBottom,
               components = {
               {
               class = "Category",
               label = "Raccourcis",
               components = {
	           {
                   class = "KeyBinder",
               	   label = "Fermer le journal",
                   description = "Raccourci pour fermer le journal. Remplace la touche \"J\" du jeu de base.",
                   variable = {
                                id = "closeKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Continuer la recherche vers l'avant",
                   description = "Raccourci pour chercher le prochain rsultat de recherche en avanant dans les entres de journal.\n\nAppuyez brivement pour passer au rsultat suivant.\nGardez la touche enfonce pour avancer page par page jusqu'au rsultat suivant.",
                   variable = {
                                id = "nextMatchKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Continuer la recherche vers l'arrire",
                   description = "Raccourci pour chercher le prochain rsultat de recherche en reculant dans les entres de journal.\n\nAppuyez brivement pour passer au rsultat suivant.\nGardez la touche enfonce pour avancer page par page jusqu'au rsultat suivant.",
                   variable = {
                                id = "prevMatchKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Continuer la recherche",
                   description = "Raccourci pour continuer la recherche, dans la direction de la dernire recherche faite (par dfaut, en reculant  partir de l'ouverture du journal). La fonction est autrement identique aux deux prcdents raccourcis de recherche.\n\nAppuyez brivement pour passer au rsultat suivant.\nGardez la touche enfonce pour avancer page par page jusqu'au rsultat suivant.",
                   variable = {
                                id = "contMatchKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Slectionner l'entre  diter (vers l'avant)",
                   description = "Raccourci pour slectionner la premire entre de journal ou la suivante pour l'diter.\n\nQuitte le mode dition lorsque vous appuyez sur cette touche sur la dernire entre visible.",
                   variable = {
                                id = "selectEditDownKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Slectionner l'entre  diter (vers l'arrire)",
                   description = "Raccourci pour slectionner la dernire entre de journal ou la prcdente pour l'diter.\n\nQuitte le mode dition lorsque vous appuyez sur cette touche sur la premire entre visible.",
                   variable = {
                                id = "selectEditUpKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Insrer une page",
                   description = "Raccourci pour insrer une nouvelle page.",
                   variable = {
                                id = "newPageInsertKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Supprimer un mot",
                   description = "Raccourci pour supprimer un mot au niveau du curseur ou juste avant.\n\nCela placera le curseur  la fin de l'entre.",
                   variable = {
                                id = "deleteWordKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Supprimer une entre",
                   description = "Raccourci pour supprimer toute l'entre en cours d'dition.",
                   variable = {
                                id = "deleteEntryKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
               	   label = "Sauvegarder et quitter le mode dition",
                   class = "KeyBinder",
                   description = "Raccourci pour sauvegarder les modifications et quitter le mode dition.",
                   variable = {
                                id = "saveEditKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Quitter le mode de recherche ou dition",
                   description = "Raccourci pour quitter le mode de recherche ou dition sans sauvegarder les modifications.",
                   variable = {
                                id = "exitKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Tourner une page vers l'avant",
                   description = "Raccourci pour tourner une page vers l'avant. Appuyez brivement pour passer  la page suivante ; gardez la touche enfonce pour avancer en continu.",
                   variable = {
                                id = "nextPageKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Tourner une page vers l'arrire",
                   description = "Raccourci pour tourner une page vers l'arrire. Appuyez brivement pour passer  la page prcdente ; gardez la touche enfonce pour reculer en continu.",
                   variable = {
                                id = "prevPageKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Insrer l'image suivante",
                   description = "Raccourci pour insrer l'image suivante, parmi les images tires des livres que vous avez lus.\n\nFonctionne pour les pages insres, aprs tre entr dans le menu d'dition, mais vous tes limit  une image par page.",
                   variable = {
                                id = "nextImageKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Insrer l'image prcdente",
                   description = "Raccourci pour insrer l'image prcdente, parmi les images tires des livres que vous avez lus.\n\nFonctionne pour les pages insres, aprs tre entr dans le menu d'dition, mais vous tes limit  une image par page.",
                   variable = {
                                id = "prevImageKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
                   {
		   label = "Incrment d'ajustement d'chelle d'une image",
                   class = "Slider",
                   description = "Incrment en pourcentage d'augmentation ou diminution de l'chelle d'une image.",
		   min = 1,
		   max = 25,
		   step = 1,
		   jump = 5,
                   variable = {
                                id = "incrImageScaleStep",
                                class = "TableVariable",
                                table = config,
                              },
                   postCreate = setSliderLabelAsPercentage,
                   updateValueLabel = setSliderLabelAsPercentage,
                   },
	           {
                   class = "KeyBinder",
               	   label = "Augmenter l'chelle d'une image",
                   description = "Raccourci pour augmenter l'chelle de l'image visible.",
                   variable = {
                                id = "incrImageScaleKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Diminuer l'chelle d'une image",
                   description = "Raccourci pour diminuer l'chelle de l'image visible.",
                   variable = {
                                id = "decrImageScaleKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
                   {
                   label = "Incrment d'ajustement de petite chelle d'une image",
                   class = "Slider",
                   description = "Incrment en pourcentage d'augmentation ou diminution de la petite chelle d'une image.",
		   min = 1,
		   max = 25,
		   step = 1,
		   jump = 5,
                   variable = {
                                id = "incrImageFineScaleStep",
                                class = "TableVariable",
                                table = config,
                              },
                   postCreate = setSliderLabelAsTenthPercentage,
                   updateValueLabel = setSliderLabelAsTenthPercentage,
                   },
	           {
                   class = "KeyBinder",
               	   label = "Augmenter la petite chelle d'une image",
                   description = "Raccourci pour augmenter la petite chelle de l'image visible.",
                   variable = {
                                id = "incrImageFineScaleKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
	           {
                   class = "KeyBinder",
               	   label = "Diminuer la petite chelle d'une image",
                   description = "Raccourci pour diminuer la petite chelle de l'image visible.",
                   variable = {
                                id = "decrImageFineScaleKeyInfo",
                                class = "TableVariable",
                                table = config,
                              },
                   },
		 },
	       },
	       {
               class = "Category",
               label = "Images",
               components = {
	           {
                   label = "Message : pas d'images",
                   class = "TextField",
                   description = "Message affich si aucune image n'est disponible pour tre insre dans le journal.\n\nC'est le cas avant que vous n'ayez ouvert en jeu un livre ou parchemin contenant une image.",
                   sNewValue = "Nouveau message en cas d'absence d'images : %s",
                   variable = {
                                id = "messageNoBookArt",
                                class = "TableVariable",
                                table = config,
                                defaultSetting = "Trouvez dans des livres des images que vous pourrez recopier dans votre journal.",
                              },
                   },
	           {
                   label = "Message : nouvelle image",
                   class = "TextField",
                   description = "Message affich quand une nouvelle image a t vue dans un livre et peut tre insre dans le journal.",
                   sNewValue = "Nouveau message en cas de nouvelle image : %s",
                   variable = {
                                id = "messageNewBookArt",
                                class = "TableVariable",
                                table = config,
                                defaultSetting = "Vous avez trouv une nouvelle image  copier dans votre journal.",
                              },
                   },
	           {
                   label = "Message : nouvelles images",
                   class = "TextField",
                   description = "Message affich quand plusieurs nouvelles images ont t vues dans un livre et peuvent tre insres dans le journal.",
                   sNewValue = "Nouveau message en cas de nouvelles images : %s",
                   variable = {
                                id = "messageNewBookArts",
                                class = "TableVariable",
                                table = config,
                                defaultSetting = "Vous avez trouv de nouvelles images  copier dans votre journal.",
                              },
                   },
                 },
	       },
	       {
               class = "Category",
               label = "Optimisation de l'affichage",
	       postCreate = padOptionsBottom,
               components = {
               {
               class = "Category",
               components = {
	           {
                   label = "Marqueur de nouvelle section de texte",
                   class = "TextField",
                   description = "Caractre(s) marquant une/des nouvelle(s) section(s) de texte.\n\nDonne une indication visuelle de l'endroit o commencer  crire en mode dition.\n\nIl est possible de laisser ce paramtre vide.",
                   sNewValue = "Marqueur de nouvelle section de texte : %s",
                   variable = {
                                id = "newTextLine",
                                class = "TableVariable",
                                table = config,
                                defaultSetting = ">",
                              },
                    },
                        {
                            label = "Caractres sauts lors d'un dplacement du curseur via les touches flches en mode dition",
                            class = "Slider",
                            description = "En mode dition, le nombre de caractres sauts lors d'un dplacement du curseur via les touches directionnelles haut/bas.\nAugmentez la valeur pour sauter plus de caractres, diminuez-la pour en sauter moins.",
				min = 5,
				max = 100,
				step = 1,
				jump = 5,
                            variable = {
                                id = "cursorUpDownJumpChar",
                                class = "TableVariable",
                                table = config,
                            },
                        },
                        {
                            label = "Cacher les en-ttes de date redondants",
                            class = "YesNoButton",
                            description = "Cache les en-ttes rptant une mme date sur chaque page, librant de la place pour diter.",
                            variable = {
                                id = "hideRedundantDateHeaders",
                                class = "TableVariable",
                                table = config,
                            },
                        },
                        {
                            label = "Compression de l'espace entre les sujets",
                            class = "Slider",
                            description = "Pourcentage d'espace standard entre les sujets. Rduisez-le pour avoir moins d'espace entre ceux-ci et plus d'espace pour diter.",
                            variable = {
                                id = "topicSpaceCompression",
                                class = "TableVariable",
                                table = config,
                            },
                            postCreate = setSliderLabelAsPercentage,
                            updateValueLabel = setSliderLabelAsPercentage,
                        },
                        {
                            label = "Dlai de changement de pages (millisecondes)",
                            class = "Slider",
                            description = "Dlai entre chaque changement de pages affiches lorsque les touches de recherches ou de changement de page restent enfonces. Lors des tests de l'auteur, la latence tait typiquement d'environ 100 millisecondes. Rduisez cette valeur pour tourner les pages plus vite, augmentez-la si vous n'arrivez plus  tourner les pages.",
				min = 100,
				max = 1000,
				step = 5,
				jump = 50,
                            variable = {
                                id = "pageTurnDelay",
                                class = "TableVariable",
                                table = config,
                            },
                        },
                        {
                            label = "Latence de l'interface (en millisecondes)",
                            class = "Slider",
                            description = "Dlai utilis pour capturer les mises  jour de l'interface aprs les clics de souris ou appuis sur des touches. D'aprs les rapides tests de l'auteur, des valeurs entre 20 et 100 millisecondes fonctionnaient bien. Augmentez cette valeur si les fonctionnalits du journal ne semblent plus rpondre  vos actions.",
				step = 5,
				jump = 10,
				min = 10,
				max = 200,
                            variable = {
                                id = "uiLatency",
                                class = "TableVariable",
                                table = config,
                            },
                        },
		    },
		 },
	       },
	       },
               {
               class = "Category",
               label = "Configuration par dfaut",
               components = {
	           {
                      class = "YesNoButton",
                      description = "Restaure les paramtres par dfaut.",
		      label = "Paramtres par dfaut",
                      variable = {
                                   id = "restoreDefaults",
                                   class = "TableVariable",
                                   table = config,
                        },
                        getText = restoreGetText,
		        postCreate = registerRestoreDefaultsButton,
                     },
                  },
               },
            },
            },
	    },
            sidebarComponents = {
                {
                    class = "MouseOverInfo",
                    text = "Amlioration du journal 1.12.\n\nPour rechercher :\nCommencez tout simplement  crire quelque chose.\nAppuyez brivement sur les raccourcis du mod pour trouver le rsultat suivant ou prcdent dans les pages affiches du journal.\nGardez les raccourcis enfoncs pour trouver des rsultats dans les pages suivantes ou prcdentes.\n\nPour diter une entre, naviguez dans les entres avec les raccourcis correspondants (par dfaut, Shift+PgUp/PgDn) et procdez aux modifications.\n\nRfrez-vous aux descriptions des raccourcis dans ce MCM pour plus d'informations."
                },
                {
                    class = "Category",
                    label = "Cr par :",
                    components = {
                        {
                            class = "Hyperlink",
                            text = "Svengineer99",
                            exec = "start https://www.nexusmods.com/morrowind/users/1121630?tab=user+files",
                        },
                     },
                },
                {
                    class = "Category",
                    label = "Crdits et remerciements :",
                    components = {
                        {
                            class = "Hyperlink",
                            text = "Hrnchamd",
                            exec = "start https://www.nexusmods.com/morrowind/users/843673?tab=user+files",
                        },
                        {
                            class = "Hyperlink",
                            text = "NullCascade",
                            exec = "start https://www.nexusmods.com/morrowind/users/26153919?tab=user+files",
                        },
                        {
                            class = "Hyperlink",
                            text = "Petethegoat",
                            exec = "start https://www.nexusmods.com/morrowind/users/45692?tab=user+files",
                        },
                        {
                            class = "Hyperlink",
                            text = "Greatness7",
                            exec = "start https://www.nexusmods.com/morrowind/users/64030?tab=user+files",
                        },
                        {
                            class = "Hyperlink",
                            text = "Merlord",
                            exec = "start https://www.nexusmods.com/morrowind/users/3040468?tab=user+files",
                        },
                        {
                            class = "Hyperlink",
                            text = "Danae",
                            exec = "start https://www.nexusmods.com/morrowind/users/1233897?tab=user+files",
                        },
                    },
                },
            },
        },
    },
    onClose = saveConfig,
}

